function redo_tree() {
	prep_tree();
    while(tree_struct.info.thetree.length<13 || tree_struct.info.thetree.lengtg>=19) {
	    prep_tree();
    }
    $("#basic-chart-source").orgChart({container: $("#chart")});
    audio["win"] = new Audio();
    audio["win"].src = "../Audio/win.m4a";
    audio["fail"] = new Audio();
    audio["fail"].src = "../Audio/fail.m4a";
    $('#newstart').prop('disabled', false);
}

var audio=[];
var mpaths=[];
var eqs=[];
var tree_struct;

var version=1;

function setver(c) {
	version=c;
}
function prep_tree() {
	 r = ['usr','var','boot','bin','spare','mnt','opt','log','lib'];
	 u = ['asidirop','vassik','jim','bob','nick','maria','george','psarnik','kgiak','dad','adam'];
	 g = ['staff','it','students','guests' ];
	 nusers=2;
	 var tree = make_a_tree('/');
	 var d=update_tree(tree);
	 tree_struct = build_tree_struct(tree, null);

	 u = ['asidirop','vassik','jim','bob','nick','maria','george','psarnik','kgiak','dad','adam'];
	 	 
	 update_homes(d[1]);
	 $('#basic-chart-source').html('<li id="root" class="root"><img src="images/bluefolder.png"/>/<ul>' + 
	 d[0] + '</ul></li>');
	 store_paths( $('#root'),'' );
	 mpaths = d[1];
}	

function random_pwd() {
	var t = tree_struct.info.thetree;
	var i;
	while(true) {
		i=Math.floor( Math.random( )*t.length);
		if(t[i].info.type=='dir') { return t[i];}
	}
}

function random_file() {
	var t = tree_struct.info.thetree;
	var i;
	i=Math.floor( Math.random( )*t.length);
	return t[i];
}

function path_to_file(pwd,file) {
  
	var i;
	if(pwd.info.visited>1) {
		return '';
	}
	pwd.info.visited++;
	var filename = file.info.name;
	if(filename in pwd.contents && pwd.contents[filename].info.path==file.info.path) {
		if(Math.floor( Math.random( )*10)==1) {
			return './'+filename;
		}
		return filename;
	}
	for(i in pwd.contents) {
		if(pwd.contents[i].info.type=='dir' && i !='.' && i !='..') {
			var p = path_to_file(pwd.contents[i],file);
			if(p!='') {
				if(Math.floor( Math.random( )*10)==1) {
					return './'+i+'/'+p;
				}
				return i+'/'+p;
				
			}
		}
	}
	i='..';
	var p = path_to_file(pwd.contents[i],file);
	if(p!='') {
		if(Math.floor( Math.random( )*10)==1) {
			return './'+i+'/'+p;
		}
		return i+'/'+p;
	}
	return '';
}

function reset_visited(){
	var t = tree_struct.info.thetree;
	for(var i=0;i<t.length;i++) {
		t[i].info.visited=0;
	}
}

function store_paths(start_e,p){

	start_e.prepend('<div class="ans">'+p+'</div>' ); 
	start_e.children('ul').children('li').each(function () {
			var x = p+'/'+this.childNodes[1].data;
			store_paths($(this),x);	
	
	}
			
	);
		

}
var rem_time=30;
var start_time;
var timer=null;
var correct=0, wrong=0;
function start_game1(){
	$('#newtree').prop('disabled', true);
	$('#newstart').prop('disabled', true);
	$('div.node').click(function () {the_click(this)});

	correct=0;
	wrong=0;
	$('#res-cor').html(correct);
	$('#res-wro').html(wrong);
	$('#res-score').html(correct-wrong);

	start_timer() ;
	
	
	next_step();
}


function next_step() {
	show_a_pwd();
	
	if(version==2) {
		last_file = random_file();
	
		reset_visited();
		a = path_to_file(last_pwd,last_file);
		show_the_path(a,last_file);
	} else {
		show_a_path();
	}
	var s = $('#the_path').val().length;
	if(s<30) {s=30;}
	$('#the_path').attr('size', s);
	
}

function the_click(ele){
	


	if(! $(ele).hasClass('node')) {return;}
	var t=$(ele).find('div.ans:first').text();
	if(t==mpaths[last_shown] || t==eqs[mpaths[last_shown]] ) {
		correct++;
		audio['win'].play();
	} else {
		wrong++;	
		audio['fail'].play();
	}
	$('#res-cor').html(correct);
	$('#res-wro').html(wrong);
	$('#res-score').html(correct-wrong);

	next_step();
}

function show_the_path(p,ele) {
	
	$('#the_path').html(p);
	last_shown=-1;
	for(i=0;i<mpaths.length;i++) {
		if(ele.info.path == mpaths[i]) {
			last_shown=i;
		}
	}
	
}
var last_shown=-1;
function show_a_path() {
	var i;
	while(true) {
		i = Math.floor( Math.random( )*mpaths.length);
		if(i!=last_shown) {
			$('#the_path').html(mpaths[i]);
			last_shown=i;
			return;
		}
	}
}
var last_pwd;
function show_a_pwd() {
	last_pwd = random_pwd();
	$('#the_cwd').html(last_pwd.info.path);
}

var timer=null;
function start_timer() {
	var d = new Date();
	 start_time = d.getTime();
	if(timer) {clearInterval(timer);}
	timer = setInterval(function(){ dec_timer(); }, 1000);
}

function dec_timer() {
	var d = new Date();
	var n = d.getTime();
	
	rem_time = 30 - Math.floor((n-start_time)/1000);
	if(rem_time<=0) { rem_time=0;}
	$('#clock').html(rem_time + " secs");
	if(rem_time<=0 && timer!=null) {
		clearInterval(timer);
		$('div.node').unbind('click');
		$('#newtree').prop('disabled', false);
		alert( $('#res').text());
	}
}

function make_graph(subtree) {
	var n=[];
	
}

function build_tree_struct(subtree,myparent,name,thetree) {

	var curnode={};
	if(thetree==null) {
		thetree=[];
		thetree.push(curnode);
	}
	curnode.info={};
	curnode.contents=[];
	curnode.info.type = 'dir';
	curnode.info.link = curnode;
	curnode.info.name=name;
	curnode.info.thetree = thetree;

	curnode.contents['.']=curnode;
	if(myparent!=null){
		curnode.contents['..']=myparent;
		curnode.info.path=myparent.info.path+"/"+name;
		curnode.info.path=curnode.info.path.replace('//','/');
	}else{
		curnode.contents['..']=curnode;
		curnode.info.path='/';
		curnode.info.name='/';
	}
	
	if($.isArray(subtree) ) {
		for(var i in subtree ) {
			if ($.isArray(subtree[i]) ) {
				curnode.contents[i] = build_tree_struct(subtree[i],curnode,i,thetree);
			} else {
				var c={};
				c.info={};
				c.info.type='file';
				c.info.name=i;
				c.info.path = curnode.info.path + "/" + i;
				c.info.path = c.info.path.replace('//','/');
				curnode.contents[i] = c;
			}
			thetree.push(curnode.contents[i]);
		}
	}

	return curnode;
}
function update_tree(subtree) {
	var txt='';
	var paths = [];
	if($.isArray(subtree) ) {
		for(var i in subtree ) {
			if ($.isArray(subtree[i]) ) {
					var d= update_tree(subtree[i]);
					txt += '<li><img src="images/bluefolder.png"/>'+i+ '<ul>'+ d[0] +'</ul></li>';
					paths.push("/"+i);
					
					for(var p in d[1]) {
						
						paths.push('/'+i+d[1][p]);			
								
					}
			} else {
					txt += 	'<li><img src="images/bluefile.png"/>'+i+'</li>';	
					paths.push("/"+i);
			}		
		
		}	
	} else {
		;
	}	
	
	return [txt,paths];
	
}	

function update_homes(paths) {
	var homes=[];
	
	for(p in paths){
		if(is_home(paths[p])) {
			var d=[];
			d['PATH']=paths[p];
			d['HOME']="~"+dirname(paths[p]);
			
			homes.push(d);
		}
	}
	for(p in paths){
		for(h in homes) {
			var r = paths[p].replace(homes[h]['PATH'],homes[h]['HOME']);
			if(r!=p) {
				paths.push(r);
				eqs[r]=paths[p];			
			}
		}
	}
	a=5;
	
}

function dirname(dir ) {
	var p = dir.split('/');
	if(p.length>0) { return p[p.length-1];}
}
function is_home(dir) {
	
	var ld = dirname(dir);
	var q=$.grep(u,function (a) {
			if(a==ld) {return true;}});
			
	if(q.length>0) {
		return true;	
	}
}

	var r = ['usr','var','boot','bin','spare','mnt','opt','log','lib'];
	var u = ['asidirop','vassik','jim','bob','nick','maria','george','psarnik','kgiak','dad','adam'];
	var g = ['staff','it','students','guests' ];
	
	var nusers=2;
	
function make_a_tree(thegroup) {
	var d = ['test','tool','fat','files','lessons','personal','public','mail'];
	var f = ['file1','test','exam','ask1','ask2','lab3','foo','bar','dim','lala'];
	
	
	var tree=[];
	if(thegroup=='/') {
		
		tree['home'] = make_a_tree('home');
		var e=2;
		for(var i=0; i< e	;i++) {
					var el = Math.floor(Math.random()*(r.length-1));
					if(el<0){el=0;}
					var a=r[el];
					//delete r[el];
					r.slice(el,el+1);
					tree[a] = make_a_tree(a);
					
		}
	
	} else if (thegroup=='home' ) {
			 tree = make_a_tree('group');
			var e=Math.random()*(3);
			//if(e<=0) return tree;
			for(var i=0; i< e	;i++) {
				var el = Math.floor(Math.random()*(g.length-1));
				if(el<0){el=0;}
				var a=g[el];
				g.slice(el,el+1);
				//delete g[el];
				tree[a] = make_a_tree('group');
				
			}
	} else if (thegroup=='group' ) {
	      
			var e=Math.random()*(nusers);
			if(e<=0) return tree;
			for(var i=0; i< e	;i++) {
				var el = Math.floor(Math.random()*(u.length-1));
				if(el<0){el=0;}
				var a=u[el];
				//delete u[el];
				u.slice(el,el+1);
				tree[a] = make_a_tree('user');
				
				nusers--;
			}
	} else if (thegroup=='user' ) {
	
			var e=Math.random()*(1);
			for(var i=0; i< e	;i++) {
				var el = Math.floor(Math.random()*(d.length-1));
				if(el<0){el=0;}
				var a=d[el];
				//delete d[el];
				d.slice(el,el+1);
				tree[a] = make_a_tree('dir');
				
			}
			var e=Math.random()*(2);
			for(var i=0; i< e	;i++) {
				var el = Math.floor(Math.random()*(f.length-1));
				if(el<0){el=0;}
				tree[f[el]] = 'file';
				//delete f[el];
				f.slice(el,el+1);
			}
	} else {
			var e=Math.random()*(2);
			for(var i=0; i< e	;i++) {
				var el = Math.floor(Math.random()*(f.length-1));
				if(el<0){el=0;}
				tree[f[el]] = 'file';
				//delete f[el];
				f.slice(el,el+1);
			}
	}
	return tree;
	
}

